/*

fellTell

*/

// Template ID, Device Name and Auth Token are provided by the Blynk.Cloud
// See the Device Info tab, or Template settings
#define BLYNK_TEMPLATE_ID "TMPLWxO5tpNF"
#define BLYNK_DEVICE_NAME "fellTell Device"
#define BLYNK_AUTH_TOKEN "2QztxgS_4uFu2ZH0qjMNmsTBjTdVpwVg"

// Comment this out to disable prints and save space
#define BLYNK_PRINT SerialUSB

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>

char auth[] = BLYNK_AUTH_TOKEN;

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = ""; // insert network name
char pass[] = ""; // insert password

// Hardware Serial on Mega, Leonardo, Micro...
#define EspSerial Serial1

// Your ESP8266 baud rate:
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

// Adjust this number for the sensitivity of the 'click' force
// this strongly depend on the range! for 16G, try 5-10
// for 8G, try 10-20. for 4G try 20-40. for 2G try 40-80
//#define CLICKTHRESHHOLD 120
float currentY, currentZ, currentTemp;
bool handlingFallingEventIsOver;
long lastMeasuredTime;

void setup()
{
  // Debug console
  SerialUSB.begin(115200);
  CircuitPlayground.begin();

  // Set ESP8266 baud rate
  EspSerial.begin(ESP8266_BAUD);
  delay(10);

  Blynk.begin(auth, wifi, ssid, pass);
  Blynk.virtualWrite(V0, 0); 
  Blynk.virtualWrite(V2, 0);

  lastMeasuredTime = millis() - (3 * 3600000); // 3 hours prior to the setup of the program
}

void loop()
{ 
  Blynk.run();

  checkIfCold(); 
  checkIfFell(); 
}

void checkIfCold() {
  currentTemp = CircuitPlayground.temperature();

  if(currentTemp < 18 && millis() - lastMeasuredTime > (3 * 3600000)) { // if elder is in a cold space, and more than 3 hours have elapsed since last alert
    Blynk.virtualWrite(V0, 3);
    lastMeasuredTime = millis();
    Blynk.virtualWrite(V0, 0);
  }
}

void checkIfFell() {
  currentY = CircuitPlayground.motionY();
  currentZ = CircuitPlayground.motionZ();

  if(currentY < 0 && currentZ < -9) {
    handleFallingEvent(); 
  }
}

void handleFallingEvent() {
   Blynk.virtualWrite(V0, 1); // elder has fallen - alert 
   handlingFallingEventIsOver = false;

   while(!handlingFallingEventIsOver) {
     Blynk.run();
     CircuitPlayground.playTone(250, 500);

     if(CircuitPlayground.leftButton() || CircuitPlayground.rightButton()) { 
       handlingFallingEventIsOver = true; 
       Blynk.virtualWrite(V0, 2); // false alarm / elder is ok
     }
   }

   Blynk.virtualWrite(V0, 0); 
}

BLYNK_WRITE(V1) {
  if(param.asInt() == 1) {
    for(int i = 0; i < 10; i++) {
      CircuitPlayground.setPixelColor(i, 0, 0, 255);
    }
  } else {
    for(int i = 0; i < 10; i++) {
      CircuitPlayground.setPixelColor(i, 0, 0, 0);
    }
  }
}

BLYNK_WRITE(V2) {
  if(param.asInt() == 1) {
    Blynk.virtualWrite(V0, 0); 
    handlingFallingEventIsOver = true;
    Blynk.virtualWrite(V2, 0);
  }
}
